global plot
	
plot:

	pusha
	add esp,36
	pop eax			; coords
	pop ebx			; pixels
	pop ecx			; count
	pop edi			; mask
	
	xor esi,esi		; zero offset
 .loop:
	add ebp,esi		; random
	xor ebp,ecx
	ror ebp,13
	mov edx,ebp
	and edx,12		; choose one
	mov edx,[eax+edx]	; offset[n]
	and esi,edi		; mask off bottom bit of y coord
	add esi,edx
	shr esi,1		; avg
	inc byte [ebx+esi]	; plot
	loopnz .loop		; if no overflow

	cmp ecx,0		; none left
	je .out
	mov byte [ebx+esi],0xff	; force to max
	jmp .loop
.out:		
	sub esp,52		; restore
	popa
	ret			; exit

	
	